import { makeSchema, objectType, enumType } from 'nexus'
import { M1, E1 } from 'nexus-prisma'
import * as customScalars from 'nexus-prisma/scalars'
import * as Path from 'path'

const types = [
  customScalars,
  enumType(E1),
  objectType({
    name: M1.$name,
    definition(t) {
      t.field('e1', {
        type: 'E1',
      })
      t.json('JsonManually')
      t.dateTime('DateTimeManually')
      t.field(M1.someJsonField.name, M1.someJsonField)
      t.field(M1.someDateTimeField.name, M1.someDateTimeField)
    },
  }),
]

makeSchema({
  types,
  shouldGenerateArtifacts: true,
  shouldExitAfterGenerateArtifacts: true,
  outputs: {
    schema: true,
    typegen: Path.join(__dirname, 'typegen.ts'),
  },
  sourceTypes: {
    modules: [{ module: '.prisma/client', alias: 'PrismaClient' }],
  },
})
